package samplepackage;

import java.util.HashMap;
import java.util.Map;

import biz.papercut.pcng.plugin.TopupAccountOnDemandPlugin.AccountType;
import biz.papercut.pcng.plugin.TopupAccountOnDemandPlugin.TopupResponse;
import biz.papercut.pcng.plugin.TopupAccountOnDemandPlugin3.AvailableCredit;
import biz.papercut.pcng.plugin.TopupAccountOnDemandPlugin4;

/**
 * A sample test harness for the SampleGateway top-up on demand gateway
 * Note that in a production system, the methods on this gateway are invoked by the PaperCut server.
 * In this test harness, the gateway is linked to the topup-on-demand-stub instead of PaperCut.
 *
 */
public class SampleGatewayTest {
	
	public static void main(String[] args) {
		SampleGateway gw = new SampleGateway();
		
		System.out.println("Gateway enabled = " + (gw.isPluginEnabled() ? "YES" : "NO"));
		
		AvailableCredit credit = gw.getAvailableCreditForTopUp("roger", null, AccountType.UserAccount);
		System.out.println("getAvailableCreditForTopUp returned available credit = " + credit.getAvailable());
		
		HashMap<String, String> userDetails = new HashMap<String, String>();
		userDetails.put(TopupAccountOnDemandPlugin4.USER_DETAILS_USERNAME, "roger");
		Map<String, Double> balance = gw.getBalance(userDetails);
		
		System.out.println("getBalance returned " + balance.size() + " items");
		for (String key : balance.keySet()) {
			System.out.println("getBalance: " + key + " = " + balance.get(key));
		}
		
		HashMap<String, String> usageDetails = new HashMap<String, String>();
		usageDetails.put("usage-type", "print");
		usageDetails.put("printer-name", "printer01");
		usageDetails.put("server-name", "server01");
		usageDetails.put("document-name", "my document");
		usageDetails.put("pages", "25");
		TopupResponse response = gw.getTopup(3.50, "roger", null, AccountType.UserAccount, usageDetails);
		
		System.out.println("getTopup responded with topupAmount = " + response.getTopupAmount());
		System.out.println("getTopup responded with transaction comment = " + response.getTransactionComment());
	}
}
