package biz.papercut.pcng.plugin;

/**
 * The available properties that can be queried upon for a user.
 */
public enum UserProperty {
    /**
     * User's primary card number of type String.
     */
    PrimaryCardNumber,
    /**
     * User's secondary card number of type String.
     */
    SecondaryCardNumber,
    /**
     * User's card PIN of type String.
     */
    CardPIN,
    /**
     * User's department of type String.
     */
    Department,
    /**
     * User's email of type String.
     */
    Email,
    /**
     * User's full name of type String.
     */
    FullName,
    /**
     * Is this user an internal user. Type: String that represents a boolean ("false"/"true").
     */
    Internal,
    /**
     * User's notes of type String.
     */
    Notes,
    /**
     * User's office of type String.
     */
    Office,
    /**
     * User's total job count. Type: String that represents an integer. ex. "5"
     */
    PrintStatsJobCount,
    /**
     * User's total page count. Type: String that represents an integer. ex. "29"
     */
    PrintStatsPageCount,
    /**
     * Does this user have restricted printing. Type: String that represents a boolean ("false"/"true").
     */
    Restricted,
    /**
     * A list of the user's other emails.
     * Type: String which is all the other emails joined by "," (ie. "email1@abc.net,email2@cba.net")
     */
    OtherEmails,
    /**
     * User's email alias of type String.
     */
    UserNameAlias,
    /**
     * If popup authentication should be used for the user. Type: String that represents a boolean ("false"/"true").
     */
    Unauthenticated,
    /**
     * The overdraft amount for the user. Type: String that represents a double. ex. "29.5"
     */
    OverdraftAmount
}
